"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var shared_1 = require("@dev-scripts/shared");
var webpack = require("webpack");
var webpackConfig;
try {
    webpackConfig = require(shared_1.projectDirectory + "/webpack.config.js")(process.env.NODE_ENV || 'development');
}
catch (e) {
    console.error(shared_1.projectDirectory + "/webpack.config.js is not found. Add a webpack.config.js to the root of your project");
}
/**
 * Creates application bundles from the source files.
 */
function bundle() {
    return new Promise(function (resolve, reject) {
        webpack(webpackConfig).run(function (err, stats) {
            if (err) {
                return reject(err);
            }
            console.info(stats && stats.toString(webpackConfig[0].stats));
            if (stats && stats.hasErrors()) {
                return reject(new Error('Webpack compilation errors'));
            }
            return resolve(true);
        });
    });
}
exports.default = bundle;
//# sourceMappingURL=bundle.js.map