"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
Object.defineProperty(exports, "__esModule", { value: true });
var shared_1 = require("@dev-scripts/shared");
var browser_sync_1 = require("browser-sync");
var express = require("express");
var path_1 = require("path");
var webpack = require("webpack");
var webpackDevMiddleware = require("webpack-dev-middleware");
var webpackHotMiddleware = require("webpack-hot-middleware");
var browserSyncServer = browser_sync_1.create();
var server = express();
var webpackConfig;
try {
    webpackConfig = require(shared_1.projectDirectory + "/webpack.config.js")(process.env.NODE_ENV || 'development');
}
catch (e) {
    console.error(shared_1.projectDirectory + "/webpack.config.js is not found. Add a webpack.config.js to the root of your project");
}
var watchOptions = {
// ignored: /node_modules/,
};
function start() {
    return __awaiter(this, void 0, void 0, function () {
        function checkForUpdate(fromUpdate) {
            var hmrPrefix = '[\x1b[35mHMR\x1b[0m] ';
            if (!app.hot) {
                throw new Error(hmrPrefix + "Hot Module Replacement is disabled.");
            }
            if (app.hot.status() !== 'idle') {
                return Promise.resolve();
            }
            return app.hot
                .check(true)
                .then(function (updatedModules) {
                if (!updatedModules) {
                    if (fromUpdate) {
                        shared_1.logMessage(hmrPrefix + "Update applied.", 'info');
                    }
                    return;
                }
                if (updatedModules.length === 0) {
                    shared_1.logMessage(hmrPrefix + "Nothing hot updated.", 'info');
                }
                else {
                    shared_1.logMessage(hmrPrefix + "Updated modules:", 'info');
                    updatedModules.forEach(function (moduleId) {
                        return shared_1.logMessage(hmrPrefix + " - " + moduleId, 'info');
                    });
                    checkForUpdate(true);
                }
            })
                .catch(function (error) {
                if (['abort', 'fail'].includes(app.hot.status())) {
                    shared_1.logMessage(hmrPrefix + "Cannot apply update.", 'warning');
                    delete require.cache[require.resolve(serverEntry)];
                    app = require(serverEntry).default;
                    shared_1.logMessage(hmrPrefix + "App has been reloaded.", 'warning');
                }
                else {
                    shared_1.logMessage(hmrPrefix + "Update failed: " + (error.stack || error.message), 'warning');
                }
            });
        }
        var clientConfig, serverConfig, serverEntry, multiCompiler, clientModernCompiler, serverCompiler, clientModernPromise, serverPromise, appPromise, appPromiseResolve, appPromiseIsResolved, app, error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    clientConfig = webpackConfig[0], serverConfig = webpackConfig[1];
                    serverEntry = path_1.resolve(shared_1.devConfig.serverDist, 'server.js');
                    clientConfig.entry.main = __spreadArray(["webpack-hot-middleware/client"], clientConfig.entry.main);
                    clientConfig.plugins.push(new webpack.HotModuleReplacementPlugin());
                    multiCompiler = webpack([clientConfig, serverConfig]);
                    clientModernCompiler = multiCompiler.compilers.find(function (compiler) { return compiler.name === 'client'; });
                    serverCompiler = multiCompiler.compilers.find(function (compiler) { return compiler.name === 'server'; });
                    clientModernPromise = shared_1.createCompilationPromise('client', clientModernCompiler);
                    serverPromise = shared_1.createCompilationPromise('server', serverCompiler);
                    server.use(webpackDevMiddleware(clientModernCompiler, {
                        publicPath: clientConfig.output.publicPath,
                        stats: clientConfig.stats,
                        serverSideRender: true,
                    }));
                    server.use(webpackHotMiddleware(clientModernCompiler));
                    server.use(shared_1.devConfig.publicPath, express.static(shared_1.devConfig.publicPath));
                    appPromiseResolve = function () {
                        /** noop */
                    };
                    appPromiseIsResolved = true;
                    serverCompiler &&
                        serverCompiler.hooks.compile.tap('server', function () {
                            if (!appPromiseIsResolved)
                                return;
                            appPromiseIsResolved = false;
                            appPromise = new Promise(function (resolve) { return (appPromiseResolve = resolve); });
                        });
                    server.use(function (req, res) {
                        appPromise.then(function () { return app.handle(req, res); }).catch(function (error) { return console.error(error); });
                    });
                    serverCompiler &&
                        serverCompiler.watch(watchOptions, function (error, stats) {
                            if (app && !error && stats && !stats.hasErrors()) {
                                checkForUpdate().then(function () {
                                    appPromiseIsResolved = true;
                                    appPromiseResolve();
                                });
                            }
                        });
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 5, , 6]);
                    return [4 /*yield*/, clientModernPromise];
                case 2:
                    _a.sent();
                    return [4 /*yield*/, serverPromise];
                case 3:
                    _a.sent();
                    shared_1.logMessage('Launching server...', 'info');
                    // Load compiled src/server.js as a middleware
                    app = require(serverEntry).default;
                    appPromiseIsResolved = true;
                    appPromiseResolve();
                    // Launch the development server with Browsersync and HMR
                    return [4 /*yield*/, new Promise(function (resolve, reject) {
                            return browserSyncServer.init(__assign(__assign({ 
                                // https://www.browsersync.io/docs/options
                                server: shared_1.devConfig.serverEntry, middleware: [server], open: false }, (shared_1.devConfig.port ? { port: shared_1.devConfig.port } : null)), { files: [
                                    {
                                        match: ['src/pages/_document.tsx', 'src/pages/_app.tsx'],
                                        fn: function () {
                                            browserSyncServer.reload();
                                        },
                                    },
                                ] }), function (error, bs) { return (error ? reject(error) : resolve(bs)); });
                        })];
                case 4:
                    // Launch the development server with Browsersync and HMR
                    _a.sent();
                    shared_1.logMessage("Server launched!", 'info');
                    return [3 /*break*/, 6];
                case 5:
                    error_1 = _a.sent();
                    shared_1.logMessage(error_1, 'error');
                    return [3 /*break*/, 6];
                case 6: return [2 /*return*/];
            }
        });
    });
}
exports.default = start;
//# sourceMappingURL=start.js.map